from zc.buildout.easy_install import working_set
from  zc.recipe.egg import Egg
import os
import errno

template = """
alias deactivate=\'export PATH=\"$_OLD_VIRTUAL_PATH\" && unset _OLD_VIRTUAL_PATH && export PYTHONPATH=\"$_OLD_VIRTUAL_PYTHON_PATH\" && unset _OLD_VIRTUAL_PYTHON_PATH && unalias deactivate\'
export VIRTUAL_ENV=%s
_OLD_VIRTUAL_PATH=\"$PATH\"
export PATH=\"$VIRTUAL_ENV:$PATH\"
export VIRTUAL_PYTHON_PATH=%s
_OLD_VIRTUAL_PYTHON_PATH=\"$PYTHONPATH\"
export PYTHONPATH=\"$VIRTUAL_PYTHON_PATH:$PYTHONPATH\"
"""

class Recipe(Egg):
  def install(self):
    super(Recipe, self).install()
    self.eggs = tuple(
      egg.strip()
      for egg in self.options['eggs'].splitlines()
      if egg.strip()
    )
    options = self.options
    self.eggs_set = working_set(
      self.eggs,
      [self.options['develop-eggs-directory'], self.options['eggs-directory']]
    )
    python_path = ":".join(tuple(dist.location for dist in self.eggs_set))

    dst = os.path.abspath(self.options['script-path'])
    self.makedirs(dst)
    file = self.options['script-path']+"/env-script"
    with open(file, "w") as f:
      f.write(template % (options['bin-directory'], python_path))
    print("/\/\/\ "+file+" /\/\/\ ")

  def makedirs(self, path):
    try:
      os.makedirs(path)
    except OSError as e:
      if e.errno != errno.EEXIST:
        raise

  update = install
